echo off
echo 
echo FOPEN*127 File Handle Upgrade Utility,  Version 3.1
echo ---------------------------------------------------
:
: Copyright (C) 1988 by Galacticomm, Inc.
:
: This batch file upgrades your C compiler run-time library to support up to
: 127 file handles (large model only).
:
:    Compilers supported:   Borland's Turbo C Compiler, versions 1.5, 2.0, 2.01
:                           Microsoft's C Compiler, version 5.1
:
:    For more information, type "A:F127 ?", or see the READ.ME file.
:
:    To patch the Microsoft COMPONENT library, type "A:F127 R"
:
:    NOTE:  if you do not have a floppy drive A:, but you do have B:, you
:    must edit this batch file and globally replace all "A:"s with "B:"s.
:
if "%1" == "?" goto help
if exist CL.LIB goto turgo
if exist LLIBCE.LIB goto micgo
if exist LLIBCR.LIB goto micgo

:help
echo FOPEN*127 will upgrade your C compiler run-time library to support up to 127
echo open files at a time.  Three different compilers are supported.  Only the
echo "LARGE" memory model is upgraded.  To run this utility, you must first select
echo the subdirectory where your library is stored.  For example, to upgrade...
echo 
echo    ...Borland's Turbo C Compiler Version 1.5, you might type:  CD \TURBOC\LIB
echo    ...Borland's Turbo C Compiler 2.0 or 2.01, you might type:  CD \TC\LIB
echo    ...Microsoft C Compiler Version 5.1, you might type:        CD \LIB
echo 
echo Then put the FOPEN*127 disk in your A: floppy drive and type:
echo 
echo      A:F127
echo 
echo This utility will automatically figure out which of the above three compilers
echo you want to upgrade by what files are available.  Before doing anything, we
echo will make a backup copy of your library.  Then we will link and run a test
echo program that counts file handles using your unchanged library.  Then we will
echo modify your library.  Finally the test program is linked and run again, and
echo reports the new quantity of file handles.  See the READ.ME file on your
echo FOPEN*127 disk for more details.
goto fin
:
:
:.............................................................................
: Patching Borland Turbo C Compiler
:
:turgo
if exist ORIGCL.LIB goto turorig
echo First, we will make a copy of your current CL.LIB in a file called ORIGCL.LIB.
echo This way, if you ever need to undo the effects of the F127 process, simply
echo copy ORIGCL.LIB back over CL.LIB.
echo 
copy cl.lib origcl.lib
goto turfine

:turorig
echo 
echo First, we will get your original copy of CL.LIB back, by copying ORIGCL.LIB
echo back over CL.LIB.
echo 
copy origcl.lib cl.lib

:turfine
echo 
echo You should now be sitting with the FOPEN*127 diskette in drive A: and your
echo "default directory" should contain your libraries.
echo 
echo Also, your CONFIG.SYS file must contain a line of the form:
echo 
echo      FILES=127
echo 
echo ...and, you must have re-booted your machine since the time that this line
echo was created.
echo 
echo If any of these conditions are not true, press CTRL/C now, and answer 'Y'
echo in response to the next question.  Otherwise
pause
:
if exist ..\tlink.exe goto gottlink
echo Cannot find your linker!  ..\TLINK.EXE does not exist!
goto fin
:gottlink
if exist c0l.obj goto gotc0l
echo Cannot find your linker preamble!  C0L.OBJ does not exist!
goto fin
:gotc0l
if exist ..\tlib.exe goto gottlib
echo Cannot find your librarian!  ..\TLIB.EXE does not exist!
goto fin
:gottlib

echo 
echo Before patching...
..\tlink c0l A:hdlcntt,hdlcnt,nul,cl
if errorlevel 1 goto fin
echo 
hdlcnt hdlcnt.exe
if errorlevel 1 goto fin

:turpatch
A:fixf127
if errorlevel 10 goto fin
echo Upgrading CL.LIB...
if errorlevel 3 goto tlib2
if errorlevel 2 goto tlib2
:
:Turbo C version 1.5
..\tlib cl -files -files2 -setenvp
..\tlib cl +A:handlest +A:setenvp
goto tlibdon
:
:Turbo C version 2.0 or 2.01
:tlib2
..\tlib cl -files -files2 -setenvp
..\tlib cl +A:handles2 +A:setenvp
:tlibdon
del cl.bak
if errorlevel 1 goto fin
echo 
echo After patching...
..\tlink c0l A:hdlcntt,hdlcnt,nul,cl
if errorlevel 1 goto fin
echo 
hdlcnt hdlcnt.exe
del hdlcnt.exe
goto fin

:.............................................................................
: Upgrading Microsoft C Version 5.1
:
:micgo
if "%1" == "R" goto micr
if "%1" == "r" goto micr

:mice
: No "R" option, assume Library is in COMBINED form
if exist LLIBCE.LIB goto miceok
echo 
echo LLIBCE.LIB does not exist (but LLIBCR.LIB does)!
echo 
echo You have installed your Microsoft compiler libraries in the "COMPONENT" form
echo (with the floating point routines unbundled from the other routines).  To
echo upgrade your library, use the "R" option by typing:
echo 
echo      A:F127 R
echo 
goto fin
:
:miceok
A:us51proc E A:

:micr
echo "R" option:  upgrade the component library LLIBCR.LIB.
if exist LLIBCR.LIB goto microk
echo 
echo LLIBCR.LIB does not exist (but LLIBCE.LIB does)!
echo 
echo You have installed your Microsoft compiler libraries in the "COMBINED" form
echo (with the floating point routines bundled with the other routines).  To
echo upgrade your library, run FOPEN*127 without the "R" option by typing:
echo 
echo      A:F127
echo 
goto fin
:
:microk
A:us51proc R A:

:fin
